use crate::advanced::LedCode;

impl From<LedCode> for &str {
    fn from(k: LedCode) -> Self {
        (&k).into()
    }
}

impl From<&LedCode> for &str {
    fn from(k: &LedCode) -> Self {
        #[allow(clippy::match_same_arms)]
        match k {
            LedCode::VolUp => "Volume Up",
            LedCode::VolDown => "Volume Down",
            LedCode::MicMute => "Mute Mic",
            LedCode::RogApp => "ROG",
            LedCode::RogFan => "Fan Control",
            LedCode::Esc => "Escape",
            LedCode::F1 => "F1",
            LedCode::F2 => "F2",
            LedCode::F3 => "F3",
            LedCode::F4 => "F4",
            LedCode::F5 => "F5",
            LedCode::F6 => "F6",
            LedCode::F7 => "F7",
            LedCode::F8 => "F8",
            LedCode::F9 => "F9",
            LedCode::F10 => "F10",
            LedCode::F11 => "F11",
            LedCode::F12 => "F12",
            LedCode::Del => "Delete",
            LedCode::Tilde => "Tilde",
            LedCode::N1 => "1",
            LedCode::N2 => "2",
            LedCode::N3 => "3",
            LedCode::N4 => "4",
            LedCode::N5 => "5",
            LedCode::N6 => "6",
            LedCode::N7 => "7",
            LedCode::N8 => "8",
            LedCode::N9 => "9",
            LedCode::N0 => "0",
            LedCode::Hyphen => "-",
            LedCode::Equals => "=",
            LedCode::Backspace => "Backspace",
            LedCode::Backspace3_1 => "Backspace LED 1",
            LedCode::Backspace3_2 => "Backspace LED 2",
            LedCode::Backspace3_3 => "Backspace LED 3",
            LedCode::Home => "Home",
            LedCode::Tab => "Tab",
            LedCode::Q => "Q",
            LedCode::W => "W",
            LedCode::E => "E",
            LedCode::R => "R",
            LedCode::T => "T",
            LedCode::Y => "Y",
            LedCode::U => "U",
            LedCode::I => "I",
            LedCode::O => "O",
            LedCode::P => "P",
            LedCode::LBracket => "[",
            LedCode::RBracket => "]",
            LedCode::BackSlash => "\\",
            LedCode::PgUp => "Page Up",
            LedCode::Caps => "Caps Lock",
            LedCode::A => "A",
            LedCode::S => "S",
            LedCode::D => "D",
            LedCode::F => "F",
            LedCode::G => "G",
            LedCode::H => "H",
            LedCode::J => "J",
            LedCode::K => "K",
            LedCode::L => "L",
            LedCode::SemiColon => ";",
            LedCode::Quote => "'",
            LedCode::Return => "Return",
            LedCode::Return3_1 => "Return LED 1",
            LedCode::Return3_2 => "Return LED 2",
            LedCode::Return3_3 => "Return LED 3",
            LedCode::PgDn => "Page Down",
            LedCode::LShift => "Left Shift",
            LedCode::LShift3_1 => "Left Shift LED 1",
            LedCode::LShift3_2 => "Left Shift LED 2",
            LedCode::LShift3_3 => "Left Shift LED 3",
            LedCode::Z => "Z",
            LedCode::X => "X",
            LedCode::C => "C",
            LedCode::V => "V",
            LedCode::B => "B",
            LedCode::N => "N",
            LedCode::M => "M",
            LedCode::Comma => ",",
            LedCode::Period => ".",
            LedCode::Star => "*",
            LedCode::NumPadDel => "Delete",
            LedCode::NumPadPlus => "+",
            LedCode::NumPadEnter => "Enter",
            LedCode::NumPadPause => "Pause",
            LedCode::NumPadPrtSc => "Print Screen",
            LedCode::NumPadHome => "Home",
            LedCode::NumLock => "Num-Lock",
            LedCode::FwdSlash => "/",
            LedCode::Rshift => "Right Shift",
            LedCode::Rshift3_1 => "Right Shift LED 1",
            LedCode::Rshift3_2 => "Right Shift LED 2",
            LedCode::Rshift3_3 => "Right Shift LED 3",
            LedCode::End => "End",
            LedCode::LCtrl => "Left Control",
            LedCode::LFn => "Left Fn",
            LedCode::Meta => "Meta",
            LedCode::LAlt => "Left Alt",
            LedCode::Spacebar => "Space",
            LedCode::Spacebar5_1 => "Space LED 1",
            LedCode::Spacebar5_2 => "Space LED 2",
            LedCode::Spacebar5_3 => "Space LED 3",
            LedCode::Spacebar5_4 => "Space LED 4",
            LedCode::Spacebar5_5 => "Space LED 5",
            LedCode::RAlt => "Right Alt",
            LedCode::PrtSc => "Print Screen",
            LedCode::RCtrl => "Right Control",
            LedCode::Pause => "Pause",
            LedCode::Up => "Up",
            LedCode::Down => "Down",
            LedCode::Left => "Left",
            LedCode::Right => "Right",
            LedCode::RFn => "Right Fn",
            LedCode::MediaPlay => "Media Play",
            LedCode::MediaStop => "Media Stop",
            LedCode::MediaNext => "Media Next",
            LedCode::MediaPrev => "Media Previous",
            LedCode::LidLogo => "Lid Logo",
            LedCode::LidLeft => "Lid Left",
            LedCode::LidRight => "Lid Right",
            LedCode::LightbarRight => "Lightbar Right",
            LedCode::LightbarRightCorner => "Lightbar Right Corner",
            LedCode::LightbarRightBottom => "Lightbar Right Bottom",
            LedCode::LightbarLeftBottom => "Lightbar Left Bottom",
            LedCode::LightbarLeftCorner => "Lightbar Left Corner",
            LedCode::LightbarLeft => "Lightbar Left",
            LedCode::Spacing | LedCode::Blocking => "",
            LedCode::SingleZone => "Single Zoned Keyboard",
            LedCode::ZonedKbLeft => "Left Zone (zone 1)",
            LedCode::ZonedKbLeftMid => "Center-left Zone (zone 2)",
            LedCode::ZonedKbRightMid => "Center-right Zone (zone 3)",
            LedCode::ZonedKbRight => "Right Zone (zone 4)",
        }
    }
}
